﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;

using Autodesk.AutoCAD.Windows;
using Autodesk.AutoCAD.ApplicationServices;
using Autodesk.AutoCAD.Runtime;

namespace MotionAddon
{
    public class ACMInterface
    {
        //create a Palette for Motion Explorer 
        static PaletteSet ps_ACMExplorer;
        //create a user control object that includes a tree view
        static public System.Windows.Forms.UserControl aACMExplorer = new ACMExplorer();

        [CommandMethod("CreateExplorer")]
        public void CreateACMExplorer()
        {
            //check if the palette set existed
            if (ps_ACMExplorer != null)
            {
                ps_ACMExplorer.Visible = true;
            }
            else
            {
                //create the palette set when it doesn't exist 
                ps_ACMExplorer = new PaletteSet("Motion Explorer");
                ps_ACMExplorer.Size = new System.Drawing.Size(180, 360);
                ps_ACMExplorer.MinimumSize = new System.Drawing.Size(180, 360);
                ps_ACMExplorer.Add("Motion", aACMExplorer);
                ps_ACMExplorer.Visible = true;
                ps_ACMExplorer.Dock = DockSides.Left;
            }
        }

        //dialog
        static DPlayer DP = new DPlayer();
        static DSimulationSetting DSS = new DSimulationSetting();
        static DSimulator DS = new DSimulator();
        static DAddASMMarker DAASMM = new DAddASMMarker();
        static DAddPart DAP = new DAddPart();
        static DAddMarker DAM = new DAddMarker();
        static DAddJoint DAJ = new DAddJoint();
        static DAddRevoluteJoint DARJ = new DAddRevoluteJoint();
        static DAddContraint DAC = new DAddContraint();
        static DEditMarker DEM = new DEditMarker();
        static DACMRegistration DACMR = new DACMRegistration();

        //method
        public void CreatePlayer()
        {
            Application.ShowModelessDialog(DP);
        }
        public void CreateSimulationSettingDialog()
        {
            Application.ShowModalDialog(DSS);
        }
        public void CreateSimulatorDialog()
        {
            Application.ShowModalDialog(DS);
        }
        public void CreateAddASMMarkerDialog()
        {
            Application.ShowModalDialog(DAASMM);
        }
        public void CreateAddPartDialog()
        {
            Application.ShowModalDialog(DAP);
        }
        public void CreateAddMarkerDialog()
        {
            Application.ShowModalDialog(DAM);
        }
        public void CreateAddJointDialog()
        {
            Application.ShowModalDialog(DAJ);
        }
        public void CreateInsertNewRevoluteJointDialog()
        {
            Application.ShowModalDialog(DARJ);
        }
        public void CreateAddConstraintDialog()
        {
            Application.ShowModelessDialog(DAC);
        }
        public void CreateEditMarkerDialog()
        {
            Application.ShowModalDialog(DEM);
        }
        public void CreateRegistrationDialog()
        {
            Application.ShowModalDialog(DACMR);
        }

    }
}
