﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Reflection;
using Autodesk.AutoCAD.Windows;
using Autodesk.AutoCAD.ApplicationServices;
using Autodesk.AutoCAD.DatabaseServices;
using Autodesk.AutoCAD.EditorInput;
using Autodesk.AutoCAD.Runtime;
using Autodesk.AutoCAD.Geometry;
using Autodesk.AutoCAD.Customization;
using Autodesk.AutoCAD.GraphicsInterface;
using System.Collections.Specialized;


namespace MotionAddon
{
    public class ACMMenu
    {
        public ACMMenu()
        {
        }

        //Context Menu Click
        void Click_Explorer(object Sender, EventArgs e)
        {
            ACMMainClass.aACMInterface.CreateACMExplorer();
        }
        void Click_Simulator(object Sender, EventArgs e)
        {

        }
        void Click_Player(object Sender, EventArgs e)
        {
            ACMMainClass.aACMInterface.CreatePlayer();
        }

        public void CreateACMContextMenu()
        {
            try
            {
                //Create a ContextMenuExtension
                ContextMenuExtension ACMContextMenu = new ContextMenuExtension();
                //Title
                ACMContextMenu.Title = "Motion";
                //Create menu item
                MenuItem menuItem_1 = new MenuItem("Motion Explorer");
                MenuItem menuItem_2 = new MenuItem("Enable Simulator");
                MenuItem menuItem_3 = new MenuItem("Player");
                ACMContextMenu.MenuItems.Add(menuItem_1);
                ACMContextMenu.MenuItems.Add(menuItem_2);
                ACMContextMenu.MenuItems.Add(menuItem_3);
                menuItem_1.Click += new EventHandler(Click_Explorer);
                menuItem_2.Click += new EventHandler(Click_Simulator);
                menuItem_3.Click += new EventHandler(Click_Player);
                //Add the ContextMenuExtension to the DefaultContextMenuExtension
                Autodesk.AutoCAD.ApplicationServices.Application.AddDefaultContextMenuExtension(ACMContextMenu);
            }
            catch
            {
            }
        }

        public void CheckCUIMenu()
        {
            const string ACMCUIFile = "c:\\Motion.cuix";
            const string MenuName = "Motion";

            string sMainCUI = Application.GetSystemVariable("MENUNAME") + ".cuix";

            CustomizationSection MainCUI = new CustomizationSection(sMainCUI);
            PartialCuiFileCollection pcfc = MainCUI.PartialCuiFiles;

            Editor ed = Application.DocumentManager.MdiActiveDocument.Editor;

            if (pcfc.Contains(ACMCUIFile))
            {
                ed.WriteMessage("\nACMotion menu loaded...");
            }
            else
            {
                if (System.IO.File.Exists(ACMCUIFile))
                {
                    ed.WriteMessage("\nTrying to load menu...");
                }

                else
                {
                    ed.WriteMessage("\nMenu not found...\n Building menu...");

                    CustomizationSection CusSec = new CustomizationSection();
                    CusSec.MenuGroupName = MenuName;
                    //Macro
                    MacroGroup mg = new MacroGroup(MenuName, CusSec.MenuGroup);
                    MenuMacro mm1 = new MenuMacro(mg, "LoadExplorer", "CreateExplorer", "ID_Load");
                    MenuMacro mm2 = new MenuMacro(mg, "Simulation", "Simulation", "ID_Simulation");

                    StringCollection sc = new StringCollection();
                    sc.Add("POP15");

                    PopMenu pm = new PopMenu(MenuName, sc, "ID_POP", CusSec.MenuGroup);
                    PopMenuItem pmi1 = new PopMenuItem(mm1, "Motion Explorer", pm, -1);
                    PopMenuItem pmi2 = new PopMenuItem(mm2, "Simulation", pm, -1);
                    System.IO.Directory.CreateDirectory(@"C:\Motion");
                    CusSec.SaveAs(ACMCUIFile);

                    ed.WriteMessage("\nFile Saved");
                }
            }
      
        }       
    }
}



