﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Autodesk.AutoCAD.DatabaseServices;
using Autodesk.AutoCAD.Geometry;
using Autodesk.AutoCAD.ApplicationServices;

namespace MotionAddon
{
    public class classMovingPart : System.Object
    {
        public classMovingPart() { }
        public classMovingPart(string ObjectName, ObjectId ObjectID, int AngleOfRotation, Vector3d AxisofRotation, Point3d BasePoint)
        {
            this._Name = ObjectName;
            this._ID = ObjectID;
            this._AngleOfRotation = AngleOfRotation;
            this._AxisOfRotation = AxisofRotation;
            this._BasePoint = BasePoint;
        }

        private string _Name;
        private ObjectId _ID;
        private int _AngleOfRotation;
        private Vector3d _AxisOfRotation;
        private Point3d _BasePoint;

        public string ObjectName
        {
            set { _Name = value; }
            get { return _Name; }
        }
        public ObjectId ObjectID
        {
            set { _ID = value; }
            get { return _ID; }
        }
        public int AngleOfRotation
        {
            set { _AngleOfRotation = value; }
            get { return _AngleOfRotation; }
        }
        public Vector3d AxisofRotation
        {
            set { _AxisOfRotation = value; }
            get { return _AxisOfRotation; }
        }
        public Point3d BasePoint
        {
            set { _BasePoint = value; }
            get { return _BasePoint; }
        }




        public void MotionThreadFunction()
        {
            try
            {
                ACMExplorer M_E = (ACMExplorer)ACMInterface.aACMExplorer;
                for (int count = 0; count < this.AngleOfRotation; count++)
                {
                    using (Transaction Trans = ACMExplorer.ProjectDocument.TransactionManager.StartTransaction())
                    {
                        //Get the Solid3d
                        Solid3d MovingSolid = (Solid3d)Trans.GetObject(this.ObjectID, OpenMode.ForWrite);
                        if (MovingSolid != null)
                        {
                            //check if the object is in write mode
                            if (MovingSolid.IsWriteEnabled == false)
                            {   
                                MovingSolid.UpgradeOpen();
                            }
                            //Rotate the solid3d
                            MovingSolid.TransformBy(Matrix3d.Rotation(0.0175, this.AxisofRotation, this.BasePoint));
                        }
                        Trans.Commit();
                    }
                }
            }
            catch
            {
            }
        }
    }
}
