﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace MotionAddon
{
    public partial class DAddJoint : Form
    {
        public DAddJoint()
        {
            InitializeComponent();
        }

        ACMExplorer M_E = (ACMExplorer)ACMInterface.aACMExplorer;

        private void loadMarker()
        {
            MarkerlistBox.Items.Clear();
            MarkerIComboBox.Items.Clear();
            MarkerJComboBox.Items.Clear();
            CB_JointType.Items.Clear();
            try
            {
                foreach (ACMMarker aACMMarker in ACMExplorer.aACMAssembly.cACMMarker)
                {
                    MarkerlistBox.Items.Add(aACMMarker.Name);
                    MarkerIComboBox.Items.Add(aACMMarker.Name);
                    MarkerJComboBox.Items.Add(aACMMarker.Name);
                }
                foreach (ACMPart aACMPart in ACMExplorer.aACMAssembly.cACMPart)
                {
                    foreach (ACMMarker aACMMarker in aACMPart.cACMMarker)
                    {
                        MarkerlistBox.Items.Add(aACMMarker.Name);
                        MarkerIComboBox.Items.Add(aACMMarker.Name);
                        MarkerJComboBox.Items.Add(aACMMarker.Name);
                    }
                }
                CB_JointType.Items.Add("Fixed");
                CB_JointType.Items.Add("RevoluteZ");
            }
            catch
            {
            }
        }

        private void AddJointDialog_Load(object sender, EventArgs e)
        {
            loadMarker();
        }

        private void MarkerlistBox_MouseUp(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Right)
            {
                if (MarkerlistBox.SelectedItem != null)
                {
                    Point atPoint = new Point(e.X, e.Y);
                    MarkerListMenu.Show(MarkerlistBox, atPoint);
                }
            }
        }

        private void markerIMenuItem_Click(object sender, EventArgs e)
        {
            MarkerIComboBox.Text = MarkerlistBox.SelectedItem.ToString();
        }

        private void markerJMenuItem_Click(object sender, EventArgs e)
        {
            MarkerJComboBox.Text = MarkerlistBox.SelectedItem.ToString();
        }

        private void AddButton_Click(object sender, EventArgs e)
        {
            if ((JointNameTBox.Text != "") && (MarkerIComboBox.Text != "") && (MarkerJComboBox.Text != "") && (CB_JointType.Text != ""))
            {
                M_E.AddACMJoint(JointNameTBox.Text, MarkerIComboBox.Text, MarkerJComboBox.Text, CB_JointType.Text);
            }
        }

    }
}
