﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Autodesk.AutoCAD.DatabaseServices;
using Autodesk.AutoCAD.Runtime;
using Autodesk.AutoCAD.ApplicationServices;
using Autodesk.AutoCAD.Geometry;

namespace MotionAddon
{
    class MotionEngine
    {
        static Solid3d test = null;

        [CommandMethod("AB")]
        public void AB()
        {
            if (test != null)
            {
                Document acDoc = Application.DocumentManager.MdiActiveDocument;
                Database acCurDb = acDoc.Database;
                using (Transaction Trans = acCurDb.TransactionManager.StartTransaction())
                {
                    test = Trans.GetObject(test.ObjectId, OpenMode.ForRead) as Solid3d;
                    if (test.IsWriteEnabled == false)
                    {
                        test.UpgradeOpen();
                    }
                    Vector3d vRot = new Point3d(-3, 4, 0).GetVectorTo(new Point3d(-3, -4, 0));

                    test.TransformBy(Matrix3d.Rotation(0.5236, vRot, new Point3d(-3, 4, 0)));

                    Trans.Commit();

                }
            }

        }
        [CommandMethod("AC")]
        public void AC()
        {
            for (int count = 0; count < 359; count++)
            {
                if (test != null)
                {
                    Document acDoc = Application.DocumentManager.MdiActiveDocument;
                    Database acCurDb = acDoc.Database;
                    using (Transaction Trans = acCurDb.TransactionManager.StartTransaction())
                    {
                        test = Trans.GetObject(test.ObjectId, OpenMode.ForRead) as Solid3d;

                        if (test.IsWriteEnabled == false)
                        {
                            test.UpgradeOpen();
                        }
                        Vector3d vRot = new Point3d(0, 4, 0).GetVectorTo(new Point3d(0, -4, 0));

                        test.TransformBy(Matrix3d.Rotation(0.0175, vRot, new Point3d(0, 4, 0)));

                        Trans.Commit();

                    }
                }
            }

        }

        [CommandMethod("AD")]
        public void AD()
        {
            for (int count = 0; count < 180; count++)
            {

                if (test != null)
                {

                    Document acDoc = Application.DocumentManager.MdiActiveDocument;
                    Database acCurDb = acDoc.Database;

                    using (Transaction Trans = acCurDb.TransactionManager.StartTransaction())
                    {
   
                        test = Trans.GetObject(test.ObjectId, OpenMode.ForRead) as Solid3d;

                        if (test.IsWriteEnabled == false)
                        {
                            test.UpgradeOpen();
                        }
                        Vector3d vRot = new Point3d(0, 4, 0).GetVectorTo(new Point3d(0, -4, 0));

                        test.TransformBy(Matrix3d.Rotation(0.0175, vRot, new Point3d(0, 4, 0)));
       
                        Trans.Commit();

                    }
                }
            }

            for (int count = 0; count < 180; count++)
            {

                if (test != null)
                {
                    // Get the current document and database, and start a transaction
                    Document acDoc = Application.DocumentManager.MdiActiveDocument;
                    Database acCurDb = acDoc.Database;

                    using (Transaction Trans = acCurDb.TransactionManager.StartTransaction())
                    {
                        // Open the polyline for read
                        test = Trans.GetObject(test.ObjectId, OpenMode.ForRead) as Solid3d;

                        if (test.IsWriteEnabled == false)
                        {
                            test.UpgradeOpen();
                        }
                        Vector3d vRot = new Point3d(0, 4, 0).GetVectorTo(new Point3d(0, -4, 0));

                        test.TransformBy(Matrix3d.Rotation(-0.0175, vRot, new Point3d(0, 4, 0)));
       
                        Trans.Commit();

                    }
                }
            }

        }
    }
}
